set verify off pagesize 50000
--
define inst_no=1
define slotsize=900
define rangesize=500
define start_peak_hour=8
define end_peak_hour=15

col noofslots head "No Of|Occurences" form 999,999


define  name='physical read total IO requests'
col range head " physical read|   IOPS Range" form a20
select  lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6) range,
        sum(noofslots) noofslots
from    (
        select  st/(extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst))) vpersec,
                round((extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst)))/&slotsize) noofslots
        from    (
                select  /*+ full(st) full(ss) use_hash(st)*/
                        to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS') est,
                        lag(to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS'))
                        over(order by ss.snap_id) sst,
                        ss.BEGIN_INTERVAL_TIME dest,
                        lag(ss.BEGIN_INTERVAL_TIME) over(order by ss.snap_id) dsst,
                        st.value-lag(st.value,1,0) over(order by ss.snap_id) st
                from    sys.WRH$_SYSSTAT        st,
                        sys.WRM$_SNAPSHOT       ss
                where   st.snap_id=ss.snap_id
                and     ss.INSTANCE_NUMBER = &inst_no
                and     st.INSTANCE_NUMBER = &inst_no
                and     ss.dbid=st.dbid
                and     st.stat_id in (
                        select  stat_id
                        from    v$statname
                        where   upper(name)=upper(trim('&name'))
                        )
                and     ss.snap_id in (
                        select  /*+push_subq*/
                                snap_id
                        from    sys.WRM$_SNAPSHOT
                        where   INSTANCE_NUMBER = &inst_no
                        --and     to_char(BEGIN_INTERVAL_TIME, 'HH24') between &start_peak_hour and &end_peak_hour
                        )
                )
        where   sst is not null
        and     st > 0
        and     to_char(to_date(sst, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
                = to_char(to_date(est, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
        )
group   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
order   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
/

define  name='physical write total IO requests'
col range head " physical write|   IOPS Range" form a20
select  lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6) range,
        sum(noofslots) noofslots
from    (
        select  st/(extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst))) vpersec,
                round((extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst)))/&slotsize) noofslots
        from    (
                select  /*+ full(st) full(ss) use_hash(st)*/
                        to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS') est,
                        lag(to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS'))
                        over(order by ss.snap_id) sst,
                        ss.BEGIN_INTERVAL_TIME dest,
                        lag(ss.BEGIN_INTERVAL_TIME) over(order by ss.snap_id) dsst,
                        st.value-lag(st.value,1,0) over(order by ss.snap_id) st
                from    sys.WRH$_SYSSTAT        st,
                        sys.WRM$_SNAPSHOT       ss
                where   st.snap_id=ss.snap_id
                and     ss.INSTANCE_NUMBER = &inst_no
                and     st.INSTANCE_NUMBER = &inst_no
                and     ss.dbid=st.dbid
                and     st.stat_id in (
                        select  stat_id
                        from    v$statname
                        where   upper(name)=upper(trim('&name'))
                        )
                and     ss.snap_id in (
                        select  /*+push_subq*/
                                snap_id
                        from    sys.WRM$_SNAPSHOT
                        where   INSTANCE_NUMBER = &inst_no
                        --and     to_char(BEGIN_INTERVAL_TIME, 'HH24') between &start_peak_hour and &end_peak_hour
                        )
                )
        where   sst is not null
        and     st > 0
        and     to_char(to_date(sst, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
                = to_char(to_date(est, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
        )
group   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
order   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
/

define  name='redo writes'
col range head "   redo write|   IOPS Range" form a20
select  lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6) range,
        sum(noofslots) noofslots
from    (
        select  st/(extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst))) vpersec,
                round((extract(DAY from (dest - dsst)) * 86400 + extract(HOUR from (dest - dsst)) * 3600+
                extract(MINUTE from (dest - dsst)) * 60+ extract(SECOND from (dest - dsst)))/&slotsize) noofslots
        from    (
                select  /*+ full(st) full(ss) use_hash(st)*/
                        to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS') est,
                        lag(to_char(ss.BEGIN_INTERVAL_TIME,'DAY DD-MM-YYYY HH24:MI:SS'))
                        over(order by ss.snap_id) sst,
                        ss.BEGIN_INTERVAL_TIME dest,
                        lag(ss.BEGIN_INTERVAL_TIME) over(order by ss.snap_id) dsst,
                        st.value-lag(st.value,1,0) over(order by ss.snap_id) st
                from    sys.WRH$_SYSSTAT        st,
                        sys.WRM$_SNAPSHOT       ss
                where   st.snap_id=ss.snap_id
                and     ss.INSTANCE_NUMBER = &inst_no
                and     st.INSTANCE_NUMBER = &inst_no
                and     ss.dbid=st.dbid
                and     st.stat_id in (
                        select  stat_id
                        from    v$statname
                        where   upper(name)=upper(trim('&name'))
                        )
                and     ss.snap_id in (
                        select  /*+push_subq*/
                                snap_id
                        from    sys.WRM$_SNAPSHOT
                        where   INSTANCE_NUMBER = &inst_no
                        --and     to_char(BEGIN_INTERVAL_TIME, 'HH24') between &start_peak_hour and &end_peak_hour
                        )
                )
        where   sst is not null
        and     st > 0
        and     to_char(to_date(sst, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
                = to_char(to_date(est, 'DAY DD-MM-YYYY HH24:MI:SS'),'dd-mon-yy')
        )
group   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
order   by lpad(trunc(vpersec/&rangesize) * &rangesize, 6) ||' - '||
        lpad(((trunc(vpersec/&rangesize) + 1) * &rangesize) - 1, 6)
/
exit

