set pagesize 50000 linesize 250 trimsp on
alter session set NLS_DATE_FORMAT='MON-DD HH24:MI:SS';
col REDO_IOPS format 999,999
col REDO_MBPS format   9,999.99
col WR_IOPS   format 999,999
col WR_PS     format 999,999
col WR_MBPS   format 999,999.99
col RD_IOPS   format 999,999
col RD_PS     format 999,999
col RD_MBPS   format 999,999.99
col SNAP      format a20     heading 'SAMPLE|START'
col SEC       format 999,999 heading 'SAMPLE|SECONDS'
select SNAP,SEC
  ,PHY_READ_IO/SEC  RD_IOPS,  PHY_READ/SEC  RD_PS,  PHY_READ_BYTE/1024/1024/SEC  RD_MBPS
  ,PHY_WRITE_IO/SEC WR_IOPS,  PHY_WRITE/SEC WR_PS,  PHY_WRITE_BYTE/1024/1024/SEC WR_MBPS
  ,REDO_WRITE/SEC REDO_IOPS,  REDO_WRITE*(select value from v$parameter where name='db_block_size')/1024/1024 REDO_MBPS
from (
select SNAP
  ,(SNAP-lag(SNAP) over(order by SNAP))*24*60*60  SEC
  ,PHY_READ-lag(PHY_READ)             over(order by SNAP) PHY_READ
  ,PHY_READ_BYTE-lag(PHY_READ_BYTE)   over(order by SNAP) PHY_READ_BYTE
  ,PHY_READ_IO-lag(PHY_READ_IO)       over(order by SNAP) PHY_READ_IO
  ,PHY_WRITE-lag(PHY_WRITE)           over(order by SNAP) PHY_WRITE
  ,PHY_WRITE_BYTE-lag(PHY_WRITE_BYTE) over(order by SNAP) PHY_WRITE_BYTE
  ,PHY_WRITE_IO-lag(PHY_WRITE_IO)     over(order by SNAP) PHY_WRITE_IO
  ,REDO_WRITE-lag(REDO_WRITE)         over(order by SNAP) REDO_WRITE
from twl_sysstat
)
order by 1
/
exit
